# rspec/airborne/spaceborne based API tests

## Setup
If you have rvm set up reasonably on your system, the .ruby-XXX files in the apitest directory should create the rvm gemset for you. You will then need to:

```ruby
gem install bundler -v 2.1.4
bundle install
```

## Environment
| Environment Variable | values | default |
|:------ |:----- |:----- |
| TEST_ENV | dev, local, qa, staging, prod | dev |
| NAMESPACE | as in other test environments | |                    
| API_KEY   | api key for redshirt account | |
| REDSHIRT_PW | the redshirt account password | |

to invoke your service tests tests (from this directory)

```ruby
bundle exec rspec -f d
```

to only run one spec file

```ruby
bundle exec rspec -f d spec/YOUR_FEATURE_spec.rb
```

to only run part of one spec - append a ':123' where 123 is the line number in the describe or it block

to have a failing test perform and output the response using curl, change the appropriate header to dbg_header or set the environment variable ```FORCE_CURL_DEBUG=true```

## Failures
### Schema changes
In the event of a schema change, you will get a test failure of the test like:

SpAllocationScheduler introspection - graphql schema changes for sp-allocation-scheduler detects schema changes for sp-allocation-scheduler

First - Alert the QE or Team member responsible for the API tests, and make sure they are aware of the schema change, and create stories to enhance the tests to fix the discrepency between the apitests in the branch/repo, and the schema changes that are part of the PR. This usually involves adding some test cases or validation for new fields or calls.

Second - You can update the supported schema on your branch so that you will no longer see the failure. This would usually be done against the pods running your service for the jenkins PR build that failed the schema change test. From your local system, in the service's apitest directory, run the following - changing the namespace to the one used for the jenkins run

```TEST_ENV=staging NAMESPACE=sp-allocation-scheduler-pr-### bundle exec rspec --tag save_schema```

This will change the schema in the supported_schemas directory on your branch, which you can then add to your PR to get the tests to pass.

The tests are not there to make your life harder, but to ensure that we don't have schema changes being deployed without QE being aware that test changes are required.